package tfg.sma.core.agent;


import jade.core.Agent;
import jade.core.IMTPException;
import jade.core.ServiceException;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.Property;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.lang.acl.ACLMessage;
import tfg.sma.core.complex.behaviours.RequestInference;
import tfg.sma.core.complex.behaviours.StateMachine;
import tfg.sma.utility.PlatformHelpers;
import jade.core.messaging.MessagingHelper;
import jade.core.messaging.MessagingService;

@SuppressWarnings("serial")
/**
 * 
 * @author jcaballeropacheco
 *
 */
public class BaseAgent extends Agent{

	public static final String RESPONDER_ALIAS = "Responder";
	public static final String INITIATOR_ALIAS = "Initiator";
	
	public BaseAgent() {
		super();
	}
	
	
	@Override
	protected void setup() {
		
		super.setup();
		
		Object [] arg = getArguments();		
		String type = "";
		
		for(int a = 0; a<arg.length;a++) {			
			type = arg[0].toString();
		}
		
		
		if(type.equals(INITIATOR_ALIAS)) {
			/*addBehaviour(new RequestInferenceSimple());
			complexInitializationInitiator();*/			
			addBehaviour(new StateMachine(this, type));
			//createAlias(INITIATOR_ALIAS);
			
		}else if(type.equals(RESPONDER_ALIAS)) {
			/*addBehaviour(new PerformInferenceSimple());
			addBehaviour(new PerformInference(this, MessageTemplate.MatchAll()));*/
			addBehaviour(new StateMachine(this, type));
			//createAlias(RESPONDER_ALIAS);
		}else {
			System.out.println("Unknown type, not starting any agent.");
			this.takeDown();
		}		
		registrarDF(type);		
	}
	
	public void createAlias(String alias) {
		MessagingHelper helper;
		try {
			 helper = (MessagingHelper) getHelper(MessagingService.NAME);
			 helper.createAlias(alias);
		}catch(ServiceException | IMTPException e) {
			System.out.println(e.getMessage());
		}
	}
	
	
	public void complexInitializationInitiator() {
		/*Property p = new Property();
		p.setName("Tipus");
		p.setValue("Responder");
		Property[] properties = { p };
		// Send the request
		 DFAgentDescription[] result = null;
		try {
			result = PlatformHelpers.getMatchingAgents(this,"Responder", "BaseAgent","TFG-SMA",
					properties);			
		} catch (FIPAException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}				
		ACLMessage m = new ACLMessage(ACLMessage.REQUEST);
		m.addReceiver(result[0].getName());
		addBehaviour(new RequestInference(this, m));*/
	
	}
	
	
	@Override
	protected void takeDown() {
		// TODO Auto-generated method stub
		super.takeDown();
		deRegistrarDF();
	}
		
	 
	public void registrarDF(String type) {
		 
		DFAgentDescription dfd = new DFAgentDescription();
		ServiceDescription sd = new ServiceDescription();
		
		sd.setName(type);
		sd.setType("BaseAgent");
		sd.setOwnership("TFG-SMA");
		
		Property p = new Property();
		p.setName("Tipus");
		p.setValue(type);
		sd.addProperties(p);
		
		dfd.addServices(sd);
		dfd.setName(getAID());
		
		try {
			DFService.register(this,  dfd);
			System.out.println("Agent: "+type+" Registrat!");
		}catch(FIPAException e) {
			
		}	
	}
	
	public void deRegistrarDF() {
		try {
			DFService.deregister(this);
		}catch(Exception e) {
			
		}
	}
	

	
}
