package tfg.sma.core.agent;

import jade.core.Agent;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.Property;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.wrapper.AgentContainer;
import jade.wrapper.StaleProxyException;

@SuppressWarnings("serial")
public class HiveAgent extends Agent{
		/**
		 * Agent that set everything up.
		 */
		public HiveAgent() {
			super();
		}
				
		@Override
		protected void setup() {
			AgentContainer container = (AgentContainer)getContainerController(); // get a container controller for creating new agents			
			try {
				container.createNewAgent("Responder", "tfg.sma.core.agent.BaseAgent", new String[] {"Responder"}).start();
				System.out.println("Agent Hive esperant 2s...");
				this.doWait(new Long("2000"));
				container.createNewAgent("Initiator", "tfg.sma.core.agent.BaseAgent", new String[] {"Initiator"}).start();
			} catch (StaleProxyException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				takeDown();
			}			
			registrarDF("Hive");
			
		}
		
		@Override
		protected void takeDown() {
			// TODO Auto-generated method stub
			super.takeDown();
			deRegistrarDF();
		}
			
		 
		public void registrarDF(String type) {
			 
			DFAgentDescription dfd = new DFAgentDescription();
			ServiceDescription sd = new ServiceDescription();
			
			sd.setName(this.getClass().toString());
			sd.setType("HiveAgent");
			sd.setOwnership("TFG-SMA");
			
			Property p = new Property();
			p.setName("Tipus");
			p.setValue(type);
			sd.addProperties(p);
			
			dfd.addServices(sd);
			dfd.setName(getAID());
			
			try {
				DFService.register(this,  dfd);
				System.out.println("Agent: "+type+" Registrat!");
			}catch(FIPAException e) {
				
			}	
		}
		
		public void deRegistrarDF() {
			try {
				DFService.deregister(this);
			}catch(Exception e) {
				
			}
		
		}
		
}
