package tfg.sma.core.behaviours;

import jade.core.behaviours.Behaviour;
import jade.core.behaviours.DataStore;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;

@SuppressWarnings("serial")
public class Receiver extends Behaviour {

	public static final String INPUTMESSAGE = "InputMessage";
	public static final int OK = 0;
	public static final int KO = -1;
	private int status;
	
	public Receiver(DataStore ds) {
		this.setDataStore(ds);
	}	
	@Override
	public void action() {
		status = KO;
		//blocks and suspends the whole agent until a message is available in the queue.
		ACLMessage inputMessage = myAgent.blockingReceive(MessageTemplate.MatchAll());
		this.getDataStore().put(INPUTMESSAGE, inputMessage);
		status = OK;		
	}

	@Override
	public boolean done() {
		return status == OK;
	}
	
	@Override
	public int onEnd() {
		return status;
		
	}
}
