package tfg.sma.core.behaviours;

import java.util.Random;
import jade.core.AID;
import jade.core.behaviours.DataStore;
import jade.core.behaviours.OneShotBehaviour;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.lang.acl.ACLMessage;
import tfg.sma.core.agent.BaseAgent;

@SuppressWarnings("serial")
public class Sender extends OneShotBehaviour {

	public static final int OK = 0;
	public static final int KO = -1;
	private int performative;
	private int status;
	
	public Sender(DataStore ds, int performative) {
		this.setDataStore(ds);
		this.performative = performative;		
	}
	
		
	@Override
	public void action() {
		this.senderFunctionality1();
		
	}
	
	public void senderFunctionality1() {
		status = KO;
		ACLMessage inputMessage = this.getDataStore().get(Receiver.INPUTMESSAGE) != null ? (ACLMessage)this.getDataStore().get(Receiver.INPUTMESSAGE) : null;
		ACLMessage outputMessage;
		if(inputMessage != null) { //If we are sending an answer
			outputMessage = inputMessage.createReply();
			outputMessage.setPerformative(performative);
		}else { //Likely sending a request.
			outputMessage = new ACLMessage(performative);			
			DFAgentDescription [] agents = (DFAgentDescription[]) this.getDataStore().get(Searcher.FOUNDAGENTS);
						
			/*Random rand = new Random(System.currentTimeMillis());
			int randomInt = agents.length <1 ? 0:rand.nextInt(agents.length);
			outputMessage.addReceiver(agents[randomInt].getName());*/
			
			System.out.println("N agents Responder: " +agents.length);			
			outputMessage.addReceiver(agents[0].getName());			
			//Testing alias
			//outputMessage.addReceiver(new AID(BaseAgent.RESPONDER_ALIAS, false));
			
		}		
		//String content = this.getDataStore().get(Inference.RESULT) != null ? this.getDataStore().get(Inference.RESULT).toString() : "";
		//outputMessage.setContent(content);
		myAgent.send(outputMessage);
		status = OK;
	}
	
		

	@Override
	public int onEnd() {
		return status;
	}
	
}
