package tfg.sma.core.complex.behaviours;

import jade.core.Agent;
import jade.core.behaviours.FSMBehaviour;
import jade.lang.acl.ACLMessage;
import tfg.sma.core.behaviours.Receiver;
import tfg.sma.core.behaviours.Searcher;
import tfg.sma.core.behaviours.Sender;

@SuppressWarnings("serial")
public class StateMachine extends FSMBehaviour {

	public static final String RECEIVER = "Receiver";
	public static final String SENDER = "Sender";
	public static final String INFERE = "Infere";
	public static final String SEARCHER = "Searcher";

	public StateMachine(Agent a, String type) {
		super(a);
		switch (type) {
			case "Initiator":
				initiatorMode();
				break;
			case "Responder":
				responderMode();
				break;
			}
	}
	public void initiatorMode() {
		
		//Shooting messages indefinitively
		registerFirstState(new Searcher(this.getDataStore()),SEARCHER);
		registerState(new Sender(this.getDataStore(), ACLMessage.REQUEST), SENDER);
		registerState(new Receiver(this.getDataStore()), RECEIVER);
		//registerLastState(new Receiver(this.getDataStore()), RECEIVER);

		/*
		 * registerTransition, the event stuff is in terms of the onEnd event of the
		 * first behaviour
		 */
		
		//Shooting messages indefinitively
		registerTransition(SEARCHER, SENDER, Searcher.OK);
		registerTransition(SENDER, RECEIVER, Sender.OK);
		registerTransition(RECEIVER, SEARCHER, Receiver.OK); 

	}
	
	
	

	public void responderMode() {
		registerFirstState(new Receiver(this.getDataStore()), RECEIVER);
		registerState(new Sender(this.getDataStore(), ACLMessage.INFORM), SENDER);
		//registerState(new Inference("PAC4.fcl", this.getDataStore()), INFERE);

		/*
		 * registerTransition, the event stuff is in terms of the onEnd event of the
		 * first behaviour
		 */
		registerTransition(RECEIVER, INFERE, Receiver.OK);
		//registerTransition(INFERE, SENDER, Inference.OK);
		registerTransition(SENDER, RECEIVER, Sender.OK);
	}

}
