package tfg.sma.core.v2.behaviours;

import java.util.Vector;
import java.util.logging.Level;
import jade.wrapper.AgentContainer;
import jade.wrapper.StaleProxyException;
import jade.core.behaviours.Behaviour;
import tfg.sma.core.model.AgentDescriptor;
import tfg.sma.core.model.InferenceDescriptor;
import tfg.sma.core.model.SmaDescriptor;
import tfg.sma.core.v2.agent.HiveAgent;
import tfg.sma.logging.LogMessages;
import tfg.sma.utility.AgentHelpers;
import tfg.sma.utility.VectorHelpers;


@SuppressWarnings("serial")
public class BringAgents extends Behaviour {
	
	private static final String BASEAGENT ="tfg.sma.core.v2.agent.BaseAgent";
	
	public static final int OK = 0;
	public static final int KO = -1;
	private int state;
	private AgentContainer ac;
	private SmaDescriptor d;
	private Long sessionId;
	
	public BringAgents(jade.wrapper.AgentContainer container, SmaDescriptor d, Long sessionId) {
		this.ac = container;
		this.d = d;
		this.sessionId = sessionId;
	}
		
	@Override
	public void action() {
		state = KO;
		HiveAgent ha = (HiveAgent) myAgent;
		try {
			Vector<InferenceDescriptor> inferences = d.getListOfInferences();
			
			for(AgentDescriptor agDescriptor: d.getListOfAgents()) {
				InferenceDescriptor outputInferenceDesc = VectorHelpers.searchInference(agDescriptor.getOutputInferenceId(),inferences);				
				ac.createNewAgent(agDescriptor.getId()+" | "+agDescriptor.getName()+" | "+outputInferenceDesc.getName()+" | ", BASEAGENT, new Object[]{outputInferenceDesc,agDescriptor, ha.getLogger(),this.sessionId}).start();
			}
			
		} catch (StaleProxyException e) {
			AgentHelpers.logAgent(ha, Level.WARNING, LogMessages.AGENTTROUBLE.getDescription()+e);											
		}
		state = OK;		
		
	}
	
	@Override
	public boolean done() {
		return state == OK | state == KO;
	}

}
