package tfg.sma.core.v2.behaviours;

import jade.core.behaviours.Behaviour;
import jade.core.behaviours.DataStore;
import jade.lang.acl.ACLMessage;

@SuppressWarnings("serial")
public class Interaction extends Behaviour {
		
	public static final int ANSWERED = 0;	
	public static final int INFERE = 1;
	public static final int ASK = 2;
	public static final int DISPLAYGUI = 3;
	public static final int FAILURE = 4;
	public static final int NONE = -1;
	private int action;
	
	public Interaction(DataStore ds) {
		this.setDataStore(ds);
	}
		
	@Override
	public void action() {		
		ACLMessage m = (ACLMessage) this.getDataStore().get(Receiver.INPUTMESSAGE);
		//Only using preformatives.		
		switch(m.getPerformative()) {
		case ACLMessage.QUERY_IF:
			//Display the gui for input value or perform actions.
			action = DISPLAYGUI;
			break;
		case ACLMessage.REQUEST:
			//Inference			
			action = INFERE;
			break;
		case ACLMessage.INFORM_REF:
			//Answered by another Agent
			action = ANSWERED;
			break;
		case ACLMessage.FAILURE:
			//Answered by another Agent
			action = ANSWERED;
			break;	
		default:
			action = NONE;
		}
	}

	@Override
	public boolean done() {		
		return action == INFERE || action == ANSWERED || action == NONE || action == ASK || action == DISPLAYGUI;
	}
		
	@Override
	public int onEnd() {
		return action;
		
	}

}
