package tfg.sma.core.v2.complex.behaviours;

import jade.core.Agent;
import jade.core.behaviours.FSMBehaviour;
import tfg.sma.core.v2.agent.BaseAgent;
import tfg.sma.core.v2.behaviours.Answer;
import tfg.sma.core.v2.behaviours.Answered;
import tfg.sma.core.v2.behaviours.DisplayGui;
import tfg.sma.core.v2.behaviours.Inference;
import tfg.sma.core.v2.behaviours.Interaction;
import tfg.sma.core.v2.behaviours.Receiver;
import tfg.sma.core.v2.behaviours.Termination;

@SuppressWarnings("serial")
public class PrimeBehaviour extends FSMBehaviour {

	public static final String RECEIVER = "receiver";
	public static final String INTERACTION = "interaction";		
	public static final String ANSWER = "answer";
	public static final String ANSWERED = "answered";	
	public static final String INFERENCE = "infere";
	public static final String TERMINATION = "termination";
	public static final String DISPLAYGUI = "displaygui";
	public static final String ASKING = "asking";
	
		
	public PrimeBehaviour(Agent a) {
		super(a);

		BaseAgent ba = (BaseAgent) a;
		ba.setDataStore(this.getDataStore());
		
		registerFirstState(new Receiver(this.getDataStore()),RECEIVER);
		registerState(new Interaction(this.getDataStore()), INTERACTION);
		registerState(new Inference(this.getDataStore(), false), INFERENCE);
		registerState(new Answer(this.getDataStore()), ANSWER);		
		registerState(new Answered(this.getDataStore()), ANSWERED);
		registerState(new DisplayGui(this.getDataStore()), DISPLAYGUI);
		registerLastState(new Termination(), TERMINATION);
								
		registerTransition(RECEIVER, INTERACTION, -1);
		registerTransition(RECEIVER, INTERACTION, 0);		
		registerTransition(INTERACTION, INFERENCE, 1);
		registerTransition(INTERACTION, ANSWERED, 0);		
		registerTransition(INTERACTION, RECEIVER, -1);
		registerTransition(INTERACTION, DISPLAYGUI, 3);
				
		
		registerTransition(INFERENCE, ANSWER, 0); 
		registerTransition(INFERENCE, ANSWER, -1); //No value answer
		registerTransition(ANSWER, RECEIVER, 0);
		registerTransition(ANSWERED, RECEIVER, 0);		
		registerTransition(DISPLAYGUI, RECEIVER, 0);
		
	
	}
	
}
