package tfg.sma.ddbb;

public class DbConstants {

	//Sequences
	public static final String TFGSMA_SESSIONID_SEQ = "TFG_SMA_SESSION_SEQ"; 
	public static final String TFGSMA_INTERACTIONID_SEQ = "TFG_INTERACTION_SEQ";
	public static final String TFGSMA_VARIABLEID_SEQ = "TFG_VARIABLE_SEQ";
		
	//Status
	public static final String STARTED = "STARTED";
	public static final String ENDED = "ENDED";
	
	//DDL - TABLES
	public static final String TFGSMA_SESSION_CREATE = "CREATE TABLE  TFG_SMA_SESSION "+ 
				"(ISESSIONID NUMBER, "+ 
				"TSTARTDATE TIMESTAMP (6), "+ 
				"TSENDDATE TIMESTAMP (6), "+ 
				"ISIMULATION NUMBER(1,0), "+ 
				"SSIMULATION_STATUS VARCHAR2(25), "+ 
				"CONSTRAINT TFG_SMA_SESSION_PK_1 PRIMARY KEY (ISESSIONID) ENABLE )";
	
	
	public static final String TFGSMA_INTERACTION_CREATE = "CREATE TABLE TFG_SMA_SESSION_INTERACTION "+ 
			"(IINTERACTIONID NUMBER, "+ 
			"ISESSIONID NUMBER, "+ 
			"SSOURCE VARCHAR2(50), "+ 
			"STARGET VARCHAR2(50), "+ 
			"IINFERENCEID NUMBER, "+ 
			"TINTERACTIONDATE TIMESTAMP(6), " + 
			"SFCLFILENAME VARCHAR2(50), "+
			"CONSTRAINT TFG_SMA_SESSION_INTERACTION_PK PRIMARY KEY (IINTERACTIONID) ENABLE," +
			"CONSTRAINT TFG_SMA_SESSION_INTERACTION_FK FOREIGN KEY (ISESSIONID) REFERENCES TFG_SMA_SESSION (ISESSIONID) ENABLE )";
			
	public static final String TFGSMA_INTER_VARIABLE_CREATE = "CREATE table TFG_SMA_INTERACTION_VARIABLE "+
		    "(IVARIABLEID NUMBER, "+
		    "IINTERACTIONID NUMBER, "+
		    "SNAME VARCHAR2(50), "+
		    "STYPE VARCHAR2(50), "+
		    "FVALUE FLOAT, "+
		    "CONSTRAINT TFG_SMA_INTERAC_VAR_PK PRIMARY KEY (IVARIABLEID) ENABLE, "+ 
		    "CONSTRAINT TFG_SMA_INTERAC_VAR_FK FOREIGN KEY (IINTERACTIONID) REFERENCES TFG_SMA_SESSION_INTERACTION (IINTERACTIONID) ENABLE ) ";
	
	//DDL - SEQUENCES
	public static final String TFGSMA_SESSIONID_SEQ_CREATE = "CREATE SEQUENCE   TFG_SMA_SESSION_SEQ MINVALUE 1 MAXVALUE 9999999999999999999999999999 "+
															"INCREMENT BY 1 START WITH 41 CACHE 20 NOORDER  NOCYCLE";
	
	public static final String TFGSMA_INTERACTIONID_SEQ_CREATE = "CREATE SEQUENCE TFG_INTERACTION_SEQ MINVALUE 1 MAXVALUE 9999999999999999999999999999 "+ 
																 "INCREMENT BY 1 START WITH 1 CACHE 20 NOORDER  NOCYCLE";
	
	public static final String TFGSMA_VARIABLEID_SEQ_CREATE = "CREATE SEQUENCE TFG_VARIABLE_SEQ MINVALUE 1 MAXVALUE 9999999999999999999999999999 "+
															  "INCREMENT BY 1 START WITH 1 CACHE 20 NOORDER  NOCYCLE ";
	
	
	//Values used in some insertions.
	public static final String SSSOURCE_HUMAN = "HUMAN";
	
}
