package tfg.sma.logging;

import java.io.IOException;
import java.util.logging.FileHandler;
import java.util.logging.Logger;

public class LogFactory {

	
	public static final String NAME = "Logger";
	public static final String LOGFOLDERNAME = "log";
	public static final String LOGFILENAME = "SMA.log";
	
	public static Logger createLog(String classname, String pathFile, String logFileName) {
		Logger logger = Logger.getLogger(classname);
		FileHandler fh = null;
		
		try {
			
			if(pathFile != null && !pathFile.equals("")) {
				fh = new FileHandler(pathFile +"/"+logFileName, true);
			}else fh = new FileHandler(logFileName, true);
									
		} catch (SecurityException | IOException e) {					
			e.printStackTrace();
		}
		
		fh.setFormatter(new LogFormatter());
		logger.addHandler(fh);
		
		return logger;
	}
	
}
