package tfg.sma.logging;

public enum LogMessages {

	SMASTARTING(0,"Starting the SMA... "),
	HIVEAGENTREGISTERED(1, "Hive Agent registration complete "), 
	AGENTREGISTERED(2, "Agent registration complete "),
	AGENTUNREGISTERED(3,"Agent unregistration complete "),
	AGENTDOWN(4, "Agent down "),
	ANSWERING(5, "Answering "),
	ANSWERRECEIVED(6, "Answer received "),
	ASKINGVALUES(7, "Asking its input values "),
	NOAGENTSFOUND(8, "No agents found able to serve my inputs "),
	AGENTSFOUND(9, "Agents found able to serve my inputs "),
	REQUESTINGTO(10, "Requesting input values to "),
	NODATATOINFERE(11, "No input values to perform the inference "),
	INFERENCECOMPLETE(12, "Inference performed "),
	INFERENCEERROR(13, "Exception produced while infering "),
	MANUALINFERENCECOMPLETE(14, "Manual Inference performed "),
	AGENTMANUALLYFED(15, "Populated manually its input values "),
	FILLMESSAGEERROR(16, "Exception produced while filling the answer message "),
	EXTRACTIONERROR(17, "Exception produced while extracting the content from the answer message "),
	DESCRIPTORFINE(18, "Descriptor file validated "),
	DESCRIPTORTROUBLE(19, "Exception produced while parsing / validating the descriptor. "),
	DDBBFINE(20, "Database UP and ready. "),
	DDBBTROUBLE(21, "Exception produced while testing the availability of the Database or preparing it. "),
	ASKINGTROUBLE(22, "FIPAException produced while Asking. "),
	TERMINATINGJADE(23, "Shutting DOWN the JADE Runtime :( "),
	AGENTTROUBLE(24, "A troublesome agent has appeared  "),
	FCLTROUBLE(25, "Exception produced while parsing the FCL file "),
	FCLFILENOTFOUND(26, "FCL file not found  "),
	TROUBLEUNREGISTERINGAGENT(27, "FIPAException while unregistering the agent "),
	TROUBLEINSERTINGINTERACTION(28, "Exception produced while inserting the interaction to the DDBB "),
	HIVEAGENTDATATABLEEXCEPTION(29, "Exception while creating the Agent Data Table "),
	HIVEAGENTDATATABLESQLEXCEPTION(30, "Exception while creating the Agent Data Table, in terms of SQL "),
	PARSINGEXCEPTION(30, "Exception while parsing variable input data "),
	;

	private final int code;
	private final String description;

	private LogMessages(int code, String description) {
		this.code = code;
		this.description = description;
	}

	public String getDescription() {
		return description;
	}

	public int getCode() {
		return code;
	}

	@Override
	public String toString() {
		return code + ": " + description;
	}
	
}
