package tfg.sma.utility;

import java.util.logging.Level;
import jade.content.lang.Codec;
import jade.content.lang.sl.SLCodec;
import jade.content.onto.basic.Action;
import jade.core.Agent;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPANames;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.JADEAgentManagement.JADEManagementOntology;
import jade.domain.JADEAgentManagement.ShutdownPlatform;
import jade.lang.acl.ACLMessage;
import jade.wrapper.StaleProxyException;
import tfg.sma.core.v2.agent.HiveAgent;

public class PlatformHelpers {

	
	public static DFAgentDescription [] getMatchingAgents(Agent a, boolean easyThere) throws FIPAException {		
		DFAgentDescription dfd = new DFAgentDescription();				
		dfd.addServices(AgentHelpers.CannonicalServiceDescription(a, false, easyThere));		
		return DFService.search(a, dfd);
	}
	
	public static DFAgentDescription [] getAllBaseAgents(Agent a) throws FIPAException {		
		DFAgentDescription dfd = new DFAgentDescription();				
		dfd.addServices(AgentHelpers.VanilaBaseAgentServiceDescription());		
		return DFService.search(a, dfd);
	}
		
	public static void shutDownJadePlatform(Agent myAgent) {		
		ACLMessage shutdownMessage = new ACLMessage(ACLMessage.REQUEST);
        Codec codec = new SLCodec();
        myAgent.getContentManager().registerLanguage(codec);
        myAgent.getContentManager().registerOntology(JADEManagementOntology.getInstance());
        shutdownMessage.addReceiver(myAgent.getAMS());
        shutdownMessage.setLanguage(FIPANames.ContentLanguage.FIPA_SL);
        shutdownMessage.setOntology(JADEManagementOntology.getInstance().getName());
        try {
            myAgent.getContentManager().fillContent(shutdownMessage,new Action(myAgent.getAID(), new ShutdownPlatform()));
            myAgent.send(shutdownMessage);
        }
        catch (Exception e) {
            AgentHelpers.logAgent(myAgent, Level.SEVERE, ""+e);
        }
	}
	
	public static void createRmaAgent(HiveAgent a) {
		try {
			a.getContainerController().createNewAgent("rma", "jade.tools.rma.rma", new Object[0]).start();
		} catch (StaleProxyException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
}
